package org.greenstone.gsdl3.gs3build.schema;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import java.util.List;
import java.util.ArrayList;

public class Schema
{
	List children;

	public Schema(Node node)
	{
		this.children = new ArrayList();

		NodeList elements = node.getChildNodes();

		System.out.println("Schema has " + elements.getLength() + " children");
		for (int e = 0; e < elements.getLength(); e++) {
			System.out.println("Subcomponent " + e);
			// TODO: actually test what is being parsed here!
			if (elements.item(e).getNodeType() != org.w3c.dom.Node.ELEMENT_NODE) {
				continue;
			}

			System.out.println(elements.item(e));

			Element element = (Element) elements.item(e);

			String elementName = element.getLocalName();
			String fullName = element.getNodeName();
			String valueName = element.getNodeValue();

			System.out.println(elementName + " " + fullName + " " + valueName);

			if (elementName == null) {
				elementName = fullName;
			}

			System.out.println(elementName);
			elementName = SchemaNode.getElementName(elementName);

			if (elementName.equals("element")) {

				SchemaElement thisElement = new SchemaElement(element);
/*			
				NodeList attributes = element.getElementsByTagName("attribute");

				for (int i = 0; i < attributes.getLength(); i++) {
			    Element attribute = (Element) attributes.item(i);
					// handle that attribute, create its node and check what you get out
					try {
						SchemaAttribute thisAttribute = new SchemaAttribute(attribute);
						thisElement.addAttribute(thisAttribute);
					}
					catch (SchemaException ex) {
						// do nothing at the moment - though a malformed attribute should be
						// cause for throwing everything in the air
					}
				}*/
				this.children.add(thisElement);
			}
			else {
				try {
					Object child = SchemaNodeFactory.makeNode(element);
					if (child != null) {
						this.children.add(child);
					}
				}
				catch (SchemaException metaEx)
				{
				}
			}
		}
	}
}